/* -*-C-*-
 * ###################################################################
 *  occ++ - oc to C++ post-compiler for Esterel
 * 
 *  FILE: "env.h"
 *                                    created: 03/09/92 00:00:00 
 *                                last update: 26/11/97 18:16:48 
 *  Author: Frdric Boulanger
 *  E-mail: Frederic.Boulanger@supelec.fr
 *    mail: Suplec - Service Informatique
 *          Plateau de Moulon, F-91192 Gif-sur-Yvette cedex
 *     www: http://wwwsi.supelec.fr/fb/fb.html
 *  
 * ========================================================================
 * Permission to use, copy and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that:
 *   - the above copyright notice appears in all copies and,
 *   - both the copyright notice and warranty disclaimer appear in
 *     supporting documentation and,
 *   - any product making use of this software or of parts of this 
 *     software displays the following acknowledgment:
 *       "This product includes software developed by Suplec
 *        and its contributors"
 *     in the documentation or other materials provided with the product 
 *     and in all advertising material mentioning features or use of 
 *     this software.
 *     
 * Warranty disclaimer: this software is provided "as is",
 *   Suplec and Frdric Boulanger disclaim all warranties with regard 
 *   to this software, including all implied warranties of merchantability 
 *   and fitness.
 *   In no event shall Suplec or Frdric Boulanger be liable for any 
 *   special, indirect or consequential damages or any damages whatsoever 
 *   resulting from loss of use, data or profits, whether in an action of 
 *   contract, negligence or other tortuous action, arising out of or in 
 *   connection with the use or performance of this software.
 * ========================================================================
 *  Description: 
 *    This file contains machine or system dependent information
 * 
 *  History
 * 
 *  modified by  rev reason
 *  -------- --- --- -----------
 *  03/09/92 FBO 1.0 original
 *  26/11/97 FBO 4.8 support for C++ types and operators (mangled)
 * ###################################################################
 */

/* This file contains machine or system dependant information.   */
/*****************************************************************/

# define occxxVers "4.8.1"                              /* Version of occ++ */
# define copyrightStr "copyright Supelec 1992-2010"     /* Copyright string */
#if (defined(macintosh) || defined(THINK_C))            /* On the Macintosh with MPW C++ */
  static char dirSep = ':';                             /* Directory separator is ':' on the Macintosh */
  static char hFileTemplate[] = "%s%s.h";               /* Name of output interface file = <Directory><baseName>.h */
  static char hDefFileTemplate[] = "%sDef.h";           /* Name of user def include file = <BaseName>Def.h */
  static char cFileTemplate[] = "%s%s.cp";              /* Name of output C++ file = <Directory><baseName>.cp */
  static char mdfFileTemplate[] = "%s%s.mdf";           /* Name of output mdl file = <baseName><moduleName>.mdf */
  static char includeEsterel[] = "<libSync.h>";         /* Include file for library interface */
  static char classEsterel[] = "<Esterel.h>";           /* Class Esterel interface */
#else                                                   /* On Unix mips machines with DEC or ATT C++ */
  static char dirSep = '/';                             /* Directory separator is '/' for Unix */
  static char hFileTemplate[] = "%s%s.H";               /* Name of output interface file = <Directory><baseName>.H */
  static char hDefFileTemplate[] = "%sDef.H";           /* Name of user def include file = <BaseName>Def.H */
  static char cFileTemplate[] = "%s%s.C";               /* Name of output C++ file = <Directory><baseName>.C */
  static char mdfFileTemplate[] = "%s%s.mdf";           /* Name of output mdl file = <baseName><moduleName>.mdf */
  static char includeEsterel[] = "<Esterel/libSync.H>"; /* Synchronous library interface */
  static char classEsterel[] = "<Esterel/Esterel.H>";   /* Class Esterel interface */
#endif
