/* -*-C-*-
 * ###################################################################
 *  occ++ - oc to C++ post-compiler for Esterel
 * 
 *  FILE: "occxx.h"
 *                                    created: 03/09/92 00:00:00 
 *                                last update: 26/11/97 18:28:23 
 *  Author: Frdric Boulanger
 *  E-mail: Frederic.Boulanger@supelec.fr
 *    mail: Suplec - Service Informatique
 *          Plateau de Moulon, F-91192 Gif-sur-Yvette cedex
 *     www: http://wwwsi.supelec.fr/fb/fb.html
 *  
 * ========================================================================
 * Permission to use, copy and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that:
 *   - the above copyright notice appears in all copies and,
 *   - both the copyright notice and warranty disclaimer appear in
 *     supporting documentation and,
 *   - any product making use of this software or of parts of this 
 *     software displays the following acknowledgment:
 *       "This product includes software developed by Suplec
 *        and its contributors"
 *     in the documentation or other materials provided with the product 
 *     and in all advertising material mentioning features or use of 
 *     this software.
 *     
 * Warranty disclaimer: this software is provided "as is",
 *   Suplec and Frdric Boulanger disclaim all warranties with regard 
 *   to this software, including all implied warranties of merchantability 
 *   and fitness.
 *   In no event shall Suplec or Frdric Boulanger be liable for any 
 *   special, indirect or consequential damages or any damages whatsoever 
 *   resulting from loss of use, data or profits, whether in an action of 
 *   contract, negligence or other tortuous action, arising out of or in 
 *   connection with the use or performance of this software.
 * ========================================================================
 *  Description: 
 *    main entry point of occ++. Holds global data, processes options and 
 *    drives the whole translation process.
 * 
 *  History
 * 
 *  modified by  rev reason
 *  -------- --- --- -----------
 *  03/09/92 FBO 1.0 original
 *  26/11/97 FBO 4.8 support for C++ types and operators (mangled)
 * ###################################################################
 */

extern char hFileName[256];       /* Name of interface output file */
extern char cFileName[256];       /* Name of C++ output file */
extern char mdfFileName[256];     /* Name of mdf file */
extern char mdfBaseFileName[256]; /* Base name for mdf files */
extern char hDefFileName[256];    /* Name of user definitions interface file */
extern char baseName[256];        /* Basename of output files */
extern char outDirectory[256];    /* Directory for output files */
extern char *sourceFile;          /* Name of source file */
extern char tabBaseFileName[256]; /* Base name of state table files */
extern char *optIncludeEsterel;   /* Esterel Include file given by -inc */

extern int verbose;               /* Verbose flag */
extern int noDefFile;             /* No user definition file flag */
extern int cutLongLines;          /* Cut state table lines to x elements */
extern int paramClass;            /* Esterel constants are object parameters */
extern int setParam;              /* Esterel constants are settable object parameters */
extern int allowDebug;            /* Stuff C++ code with conditional debug code */
extern int separateTables;        /* Create separate files for state tables */
extern int doMDF;                 /* Create Module Description Files */
extern int refArePointers;        /* reference implemented by pointer */
extern int wantAwaitedList;       /* Create method to get awaited signals */
extern int noTickReaction;        /* activate() does nothing on ticks without signals */

void occxx();                     /* Output files generator */
