/* -*-C-*-
 * ###################################################################
 *  occ++ - oc to C++ post-compiler for Esterel
 * 
 *  FILE: "occxxParse.h"
 *                                    created: 03/09/92 00:00:00 
 *                                last update: 26/11/97 18:35:12 
 *  Author: Frdric Boulanger
 *  E-mail: Frederic.Boulanger@supelec.fr
 *    mail: Suplec - Service Informatique
 *          Plateau de Moulon, F-91192 Gif-sur-Yvette cedex
 *     www: http://wwwsi.supelec.fr/fb/fb.html
 *  
 * ========================================================================
 * Permission to use, copy and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that:
 *   - the above copyright notice appears in all copies and,
 *   - both the copyright notice and warranty disclaimer appear in
 *     supporting documentation and,
 *   - any product making use of this software or of parts of this 
 *     software displays the following acknowledgment:
 *       "This product includes software developed by Suplec
 *        and its contributors"
 *     in the documentation or other materials provided with the product 
 *     and in all advertising material mentioning features or use of 
 *     this software.
 *     
 * Warranty disclaimer: this software is provided "as is",
 *   Suplec and Frdric Boulanger disclaim all warranties with regard 
 *   to this software, including all implied warranties of merchantability 
 *   and fitness.
 *   In no event shall Suplec or Frdric Boulanger be liable for any 
 *   special, indirect or consequential damages or any damages whatsoever 
 *   resulting from loss of use, data or profits, whether in an action of 
 *   contract, negligence or other tortuous action, arising out of or in 
 *   connection with the use or performance of this software.
 * ========================================================================
 *  Description: 
 *    Information shared by lex, yacc and main.
 * 
 *  History
 * 
 *  modified by  rev reason
 *  -------- --- --- -----------
 *  03/09/92 FBO 1.0 original
 *  26/11/97 FBO 4.8 support for C++ types and operators (mangled)
 * ###################################################################
 */

extern int yyparse();      /* Yacc parse function */
extern int yydebug;        /* Yacc debug flag */
extern FILE *yyin;         /* Lex input file */
extern int lineNb;         /* Number of current line in syntax analyser */
extern int colNb;          /* Offset of last parsed char in line */
extern int yylex();        /* Lex lexical analyse function */
extern int yywrap();       /* End of input test function for lex */

#if defined(__cplusplus) || defined (c_plusplus)
#ifndef __GNUG__
extern "C" char *alloca(int);  /* Stack allocation function for yacc */
#endif
#else
#ifndef __GNUC__
extern char *alloca(int);  /* Stack allocation function for yacc */
#endif
#endif

#ifdef FLEX
extern char* yytext;       /* Last token read from source (for flex) */
#else
extern char yytext[];      /* Last token read from source (for lex) */
#endif

extern char *sourceFile;   /* Name of oc source file (in occxx.c) */

#ifdef macintosh
#if defined(__cplusplus) || defined (c_plusplus)
extern "C" void BLOCKMOVE(char *from, char *to, size_t length);
#else
extern void BLOCKMOVE(char *from, char *to, size_t length);
  /* Function used by bison on the Macintosh. Seen only in ROM maps and Interface.o */
#endif
#endif
