/* -*-C-*-
 * ###################################################################
 *  occ++ - oc to C++ post-compiler for Esterel
 * 
 *  FILE: "occxxUtils.h"
 *                                    created: 03/09/92 00:00:00 
 *                                last update: 26/11/97 18:42:28 
 *  Author: Frdric Boulanger
 *  E-mail: Frederic.Boulanger@supelec.fr
 *    mail: Suplec - Service Informatique
 *          Plateau de Moulon, F-91192 Gif-sur-Yvette cedex
 *     www: http://wwwsi.supelec.fr/fb/fb.html
 *  
 * ========================================================================
 * Permission to use, copy and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that:
 *   - the above copyright notice appears in all copies and,
 *   - both the copyright notice and warranty disclaimer appear in
 *     supporting documentation and,
 *   - any product making use of this software or of parts of this 
 *     software displays the following acknowledgment:
 *       "This product includes software developed by Suplec
 *        and its contributors"
 *     in the documentation or other materials provided with the product 
 *     and in all advertising material mentioning features or use of 
 *     this software.
 *     
 * Warranty disclaimer: this software is provided "as is",
 *   Suplec and Frdric Boulanger disclaim all warranties with regard 
 *   to this software, including all implied warranties of merchantability 
 *   and fitness.
 *   In no event shall Suplec or Frdric Boulanger be liable for any 
 *   special, indirect or consequential damages or any damages whatsoever 
 *   resulting from loss of use, data or profits, whether in an action of 
 *   contract, negligence or other tortuous action, arising out of or in 
 *   connection with the use or performance of this software.
 * ========================================================================
 *  Description: 
 *    Utility functions for C++ code generation
 * 
 *  History
 * 
 *  modified by  rev reason
 *  -------- --- --- -----------
 *  03/09/92 FBO 1.0 original
 *  26/11/97 FBO 4.8 support for C++ types and operators (mangled)
 * ###################################################################
 */

extern char *typeName(int typeNum);          /* Returns the name of the type of ID typeNum */
extern char *funcName(int funcNum);          /* Returns the name of the function of ID funcNum */
extern int funcArity(int funcNum);           /* Returns the number of arguments of the function of ID funcNum */
extern char *procName(int procNum);          /* Returns the name of the procedure of ID procNum */
extern char *opFromTag(char *funcName);      /* Returns the name of the operator corresponding to funcName according to its tag */
extern char *opFromName(char *tag);          /* Returns the name of the C++ operator corresponding to the tag */
extern int opArity(char *tag);               /* Returns the arity of the C++ operator corresponding to the tag */
extern int needsExternalH();                 /* Returns 1 if we must include an external definition file */
extern void printModule();                   /* Prints what the parser found in the source file on stderr */
extern char *checkAlloc(size_t nItems, size_t itemSize);/* Allocates storage for nItems of size itemSize, and checks for success */
extern char *fileName(char *fullFileName);   /* Yields a pointer to the file name part of a full access path name */
extern char *dateAndTime();                  /* Returns a string in the form '<Date> at <Time>' */
