#ifndef _CLASS_TASKSTASK_ADD_H_
#define _CLASS_TASKSTASK_ADD_H_

#include <Esterel/libSync.H>

// This task merely computes its result in the tstart method, so it should
// work on all systems. It just serves as an example of what you could write
// to build a correct task class for occ++.

class tasksTask_add {
  public:
    tasksTask_add(unsigned taskNum, unsigned execNum, const char *name);
    void tstart(integer& x,integer a,integer b);
    void tkill();
    void tsuspend();
    void tactivate();
    void treturn();
    void setReturn();
    OutSignal<integer>& returnSig();
    
  private:
    integer *ref;        // Storage for our reference argument
    integer res;         // Copy of this argument to work on
    const unsigned tkNum, exNum;  // Our task and exec numbers
    OutSignal<integer> fReturn;   // return signal to the Esterel world.
    SBoolean hasReturned; // Has the task returned?
    SBoolean suspended;   // Is the task suspended?
    SBoolean killed;      // Has the task been killed?
    SBoolean running;     // Is the task running?
};

#endif
