//
//  tasks.C
//  Created by occ++ v4.6
//    on Tuesday January 14 1997 at 15:39:54
//    from oc v5 source file oc6641.oc
//

#include "tasks.H"

//
//  Code of module tasks
//       root module: tasks, from file: tasks.strl

static const Esterel::tStateNumber ctasksState0ops[] = {
  0,0
};

static const Esterel::tStateNumber ctasksState1ops[] = {
  9,0,2
};

static const Esterel::tStateNumber ctasksState2ops[] = {
  5,3,0,2,4,4,10,0,3,0,2
};

static const Esterel::tStateNumber ctasksState3ops[] = {
  5,4,12,0,3,6,6,14,8,7,0,2,13,0,3
};

static const Esterel::tStateNumber *const ctasksStateOps[] = {
  ctasksState0ops,
  ctasksState1ops,
  ctasksState2ops,
  ctasksState3ops
};

// Table of automaton action numbers
const Esterel::tStateNumber *const *const tasks::ctasksStates = ctasksStateOps;

InSignal<string>& tasks::file() {
  return ffile;
}

PureInSignal& tasks::susp() {
  return fsusp;
}

OutSignal<integer>& tasks::numlinks() {
  return fnumlinks;
}

void tasks::resetOutputs() {
  fnumlinks.value().reset();
}

void tasks::resetInputs() {
  ffile.value().reset();
  fsusp.value().reset();
  fok.value().reset();
}

void tasks::setInputs() {
// Ask for the return status of the execs
  countlinks_0_0.setReturn();
  ffile.update();
  fsusp.update();
  fok.update();
}

const InputSignal** tasks::inSigList() const {
  const InputSignal** inList;
  inList = (const InputSignal**) new (InputSignal*[3]);
  inList[0] = &ffile;
  inList[1] = &fsusp;
  inList[2] = 0;
  return inList;
}

const OutputSignal** tasks::outSigList() const {
  const OutputSignal** outList;
  outList = (const OutputSignal**) new (OutputSignal*[2]);
  outList[0] = &fnumlinks;
  outList[1] = 0;
  return outList;
}

tasks::tasks(const char* name, const bool schedule)    // Constructor
        : Synchronous(name, schedule), Esterel(ctasksStates),
          ffile(this, "file"),
          fsusp(this, "susp"),
          fnumlinks(this, "numlinks"),
          fok(this, "ok"),
          countlinks_0_0(0,0,"countlinks_0_0"),
          pf_backup_copy_(0)
{
  gotoState(1);    // Set initial state
  fok << countlinks_0_0.returnSig();
}

tasks::~tasks() {
  if (pf_backup_copy_ != 0)
    delete pf_backup_copy_;
}

void tasks::backup() {
  Esterel::backup();
  if (pf_backup_copy_ == 0) {
    pf_backup_copy_ = new tasks::Data;
  }
  pf_backup_copy_->x_5 = x_5;
}

void tasks::restore() {
  if (pf_backup_copy_ != 0) {
    Esterel::restore();
  x_5 = pf_backup_copy_->x_5;
  }
}

void tasks::doAction(tActionNumber _op, Esterel::tActionNumber *_i) {
  switch (_op) {
    case kSequence:
      break;
    case kExecuteODAG:
      executeOpenDAG(_i);
      break;
    case kGotoCDAG:
      gotoClosedDAG(_i);
      break;
    case kBranchAlways:
      branchIfFalse(false,_i);
      break;
    case kPresent_file_4:
      branchIfFalse(ffile.value().isPresent(), _i);
      break;
    case kPresent_susp_5:
      branchIfFalse(fsusp.value().isPresent(), _i);
      break;
    case kPresent_ok_6:
      branchIfFalse(fok.value().isPresent(), _i);
      break;
    case kOutput_numlinks_7:
      break;
    case kCall__assign_integer_8:
      fnumlinks.value() = x_5;
      break;
    case kReset_x_5_9:
      break;
    case kStart_countlinks_t0_e0_10:
      countlinks_0_0.tstart(x_5,ffile.value().value());
      break;
    case kKill_countlinks_t0_e0_11:
      countlinks_0_0.tkill();
      break;
    case kSuspend_countlinks_t0_e0_12:
      countlinks_0_0.tsuspend();
      break;
    case kActivate_countlinks_t0_e0_13:
      countlinks_0_0.tactivate();
      break;
    case kReturn_countlinks_t0_e0_14:
      countlinks_0_0.treturn();
      break;
  }
}


