#ifndef _TASKS_H_
#define _TASKS_H_

//
//  tasks.H
//  Created by occ++ v4.6
//    on Tuesday January 14 1997 at 15:39:54
//    from oc v5 source file oc6641.oc

#include <Esterel/libSync.H>

//
//  Interface of module tasks
//       root module: tasks, from file: tasks.strl

#include "tasksDef.H"

class tasks : public Esterel {
  protected:
    enum {  // Automaton action numbers
      kSequence,
      kExecuteODAG,
      kGotoCDAG,
      kBranchAlways,
      kPresent_file_4,
      kPresent_susp_5,
      kPresent_ok_6,
      kOutput_numlinks_7,
      kCall__assign_integer_8,
      kReset_x_5_9,
      kStart_countlinks_t0_e0_10,
      kKill_countlinks_t0_e0_11,
      kSuspend_countlinks_t0_e0_12,
      kActivate_countlinks_t0_e0_13,
      kReturn_countlinks_t0_e0_14
    };

    static const Esterel::tStateNumber *const *const ctasksStates;

    void doAction(tActionNumber op, Esterel::tActionNumber *i);

    InSignal<string> ffile;
    PureInSignal fsusp;
    OutSignal<integer> fnumlinks;
    PureInSignal fok;
// Variables of module tasks
    integer x_5;

    class Data {
      public:
        integer x_5;
    } *pf_backup_copy_;

// Execs of module tasks
    tasksTask_countlinks countlinks_0_0;


  public:
    virtual InSignal<string>& file();
    virtual PureInSignal& susp();
    virtual OutSignal<integer>& numlinks();
    virtual void resetOutputs();
    virtual void resetInputs();
    virtual void setInputs();
    virtual const InputSignal** inSigList() const;  // Returns list of input signals
    virtual const OutputSignal** outSigList() const;// Returns list of output signals
    virtual void backup();
    virtual void restore();
    tasks(const char* name = "tasks",
        const bool schedule = true);  // Constructor
    ~tasks();  // Destructor
  private:
    tasks(const tasks &);  // Do not use copy constructor
};


#endif
