#ifndef _CLASS_TASKSTASK_COUNTLINKS_H_
#define _CLASS_TASKSTASK_COUNTLINKS_H_

#include <Esterel/libSync.H>
#include <sys/types.h>

// This task forks a processus that counts the number of
// links to a file (looks at the st_nlink field of struct stat).

class tasksTask_countlinks {
  public:
    tasksTask_countlinks(unsigned taskNum, unsigned execNum, const char *name);
    void tstart(integer& x,SString dir);  // Start the task (forks a new processus)
    void tkill();         // Kill the task (kills the processus)
    void tsuspend();      // Suspend the task (does nothing to the processus)
    void tactivate();     // Activate the processus (does nothing to the processus)
    void treturn();       // Make everything ok for Esterel when the task is done
    void setReturn();     // Update return signal (tests the termination of the processus)
    PureOutSignal& returnSig();
    
  private:
    integer *ref;        // Storage for our reference argument
    integer res;         // Copy of this argument to work on
    const unsigned tkNum, exNum;  // Our task and exec numbers
    PureOutSignal fReturn;// return signal to the Esterel world.
    SBoolean hasReturned; // Has the task returned?
    SBoolean suspended;   // Is the task suspended?
    SBoolean killed;      // Has the task been killed?
    SBoolean running;     // Is the task running?
    pid_t process;        // ID of the Unix processus that does the job
    void do_it(SString);  // What this processus has to do
};

#endif
